// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: scenario.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ScenarioClient is the client API for Scenario service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ScenarioClient interface {
	Create(ctx context.Context, in *ScenarioModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *ScenarioModel, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ScenarioModel, error)
	SetInitialActionId(ctx context.Context, in *ScenarioInitialRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	List(ctx context.Context, in *ScenarioListReq, opts ...grpc.CallOption) (*ScenarioModelListResp, error)
	Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error)
}

type scenarioClient struct {
	cc grpc.ClientConnInterface
}

func NewScenarioClient(cc grpc.ClientConnInterface) ScenarioClient {
	return &scenarioClient{cc}
}

func (c *scenarioClient) Create(ctx context.Context, in *ScenarioModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioClient) Update(ctx context.Context, in *ScenarioModel, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ScenarioModel, error) {
	out := new(ScenarioModel)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioClient) SetInitialActionId(ctx context.Context, in *ScenarioInitialRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/SetInitialActionId", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioClient) List(ctx context.Context, in *ScenarioListReq, opts ...grpc.CallOption) (*ScenarioModelListResp, error) {
	out := new(ScenarioModelListResp)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/List", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioClient) Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error) {
	out := new(proto.UInt64Value)
	err := c.cc.Invoke(ctx, "/botMs.Scenario/Count", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ScenarioServer is the server API for Scenario service.
// All implementations must embed UnimplementedScenarioServer
// for forward compatibility
type ScenarioServer interface {
	Create(context.Context, *ScenarioModel) (*proto.IdRequest, error)
	Update(context.Context, *ScenarioModel) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*ScenarioModel, error)
	SetInitialActionId(context.Context, *ScenarioInitialRequest) (*emptypb.Empty, error)
	List(context.Context, *ScenarioListReq) (*ScenarioModelListResp, error)
	Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error)
	mustEmbedUnimplementedScenarioServer()
}

// UnimplementedScenarioServer must be embedded to have forward compatible implementations.
type UnimplementedScenarioServer struct {
}

func (UnimplementedScenarioServer) Create(context.Context, *ScenarioModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedScenarioServer) Update(context.Context, *ScenarioModel) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedScenarioServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedScenarioServer) Get(context.Context, *proto.IdRequest) (*ScenarioModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedScenarioServer) SetInitialActionId(context.Context, *ScenarioInitialRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetInitialActionId not implemented")
}
func (UnimplementedScenarioServer) List(context.Context, *ScenarioListReq) (*ScenarioModelListResp, error) {
	return nil, status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedScenarioServer) Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Count not implemented")
}
func (UnimplementedScenarioServer) mustEmbedUnimplementedScenarioServer() {}

// UnsafeScenarioServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ScenarioServer will
// result in compilation errors.
type UnsafeScenarioServer interface {
	mustEmbedUnimplementedScenarioServer()
}

func RegisterScenarioServer(s grpc.ServiceRegistrar, srv ScenarioServer) {
	s.RegisterService(&Scenario_ServiceDesc, srv)
}

func _Scenario_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).Create(ctx, req.(*ScenarioModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Scenario_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).Update(ctx, req.(*ScenarioModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Scenario_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Scenario_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Scenario_SetInitialActionId_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioInitialRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).SetInitialActionId(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/SetInitialActionId",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).SetInitialActionId(ctx, req.(*ScenarioInitialRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Scenario_List_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioListReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).List(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/List",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).List(ctx, req.(*ScenarioListReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Scenario_Count_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioServer).Count(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Scenario/Count",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioServer).Count(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Scenario_ServiceDesc is the grpc.ServiceDesc for Scenario service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Scenario_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.Scenario",
	HandlerType: (*ScenarioServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Scenario_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Scenario_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Scenario_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _Scenario_Get_Handler,
		},
		{
			MethodName: "SetInitialActionId",
			Handler:    _Scenario_SetInitialActionId_Handler,
		},
		{
			MethodName: "List",
			Handler:    _Scenario_List_Handler,
		},
		{
			MethodName: "Count",
			Handler:    _Scenario_Count_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "scenario.proto",
}
